/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------            KopyRong (K) 1987.  ALL RIGHTS REVERSED.       */
/*                                                                          */
/*                                                                          */
/*               This module was written by Vince Perriello                 */
/*                                                                          */
/*                                                                          */
/*              BinkleyTerm External Protocol Handler Module                */
/*                                                                          */
/*                                                                          */
/*   This  software  package is being distributed WITH FULL SOURCE CODE     */
/*   with the  following  conditions:    1)  If  anything awful happens     */
/*   because  you  use    it   (or  don't  use  it),  you  accept  full     */
/*   responsibility;  2) you  don't start making tons of voice calls to     */
/*   the authors to complain or  make  suggestions  about enhancements,     */
/*   useful or otherwise;  3) you  do not reuse this code in commercial     */
/*   products without specific permission to do so  from  the  authors;     */
/*   4) If you find any problems you send  fixes  to  the  authors  for     */
/*   inclusion  in  updates;    5) You find some way  to  express  your     */
/*   appreciation  for  this  method of distribution, either by writing     */
/*   code or  application  notes,  or  just sending along a "Thank You"     */
/*   message.                                                               */
/*                                                                          */
/*   There is  copyrighted  code  in  this product.  We either wrote it     */
/*   ourselves or got  permission  to use it.  Please don't force us to     */
/*   pay a lawyer --  have some respect for our motives and don't abuse     */
/*   this "license".                                                        */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <conio.h>
#include "com.h"
#include "xfer.h"

extern char    *extern_protocols;       /* Names of external protos  */
extern struct pointers ctl;     /* where the CD mask is      */
extern int      share;          /* Whether to drop FOSSIL    */
extern FILE    *status_log;     /* Stream desc. of status    */
extern struct baud_str btypes[];/* Baud rate array           */
extern int      baud;           /* Element in use now        */

static struct
{
   char            first_char;
   int             entry;
}               protos[MAX_EXTERN];

extern int      port_ptr;       /* Port we're now using      */
extern int      cur_baud;       /* Current comp-to-mdm rate  */
extern int      lock_baud;      /* If nonzero baud is locked */

compile_externs ()
{
   register char  *c;
   register        i;
   char            junk[100];
   int             j, k, l;
   char           *p, *malloc ();
   char            x;

   i = l = 0;                   /* start at beginning  */

   for (k = 0; ctl.protocols[k] != NULL; k++)   /* Total no. of protos */
      {
      c = ctl.protocols[k];     /* Point at filename   */
      if (!dexists (c))         /* Is it there?        */
         {
         printf ("Can't find protocol module: %s\n", c);
         continue;
         }
      p = NULL;
      while (*c)                /* Until end of string */
         {
         if ((*c == '\\') || (*c == ':'))       /* Look for last path  */
            p = c;              /* Delimiter           */
         c++;
         }
      if (strlen (p) < 3)       /* If no name,         */
         continue;              /* No protocol...      */

      p++;                      /* Point to the        */
      x = toupper (*p);         /* First character     */
      if (strchr (junk, x) != NULL)
         {
         printf ("Duplicate protocol name: %s\n", c);
         continue;
         }

      protos[l].first_char = x; /* Makes lookup fast   */
      protos[l++].entry = k;    /* Now we know where   */

      junk[i++] = x;            /* Store first char    */
      junk[i++] = ')';          /* Then a ')'          */
      c = ++p;                  /* Point to 2nd char   */
      for (j = 0; j < 9; j++)   /* Up to 9 chars more  */
         {
         if (*c != '.')         /* If no comma yet,    */
            {
            junk[i++] = tolower (*c);   /* store the char and  */
            ++c;                /* bump the pointer    */
            }
         else
            junk[i++] = ' ';    /* otherwise pad it    */
         }
      junk[i++] = ' ';          /* And one more space  */
      junk[i] = '\0';           /* Need for testing    */
      }

   if (!i)                      /* If we got none,     */
      return;                   /* Return now.         */

   i += 2;                      /* Total for malloc    */
   if ((extern_protocols = malloc (i)) == NULL) /* Allocate string     */
      return;                   /* Return on failure   */
   strcpy (extern_protocols, junk);     /* Copy the string     */
   return;                      /* Back to caller      */
}

do_extern (cmd, prot, name)
char           *cmd;            /* "Get" or "Send"     */
char            prot;           /* 1st letter of proto */
char           *name;           /* Name of file        */
{
   int             i, j;
   char            junk[100];
   char           *c, *p, *m;
   FILE           *ctlfile;

   for (j = 0; j < 100; j++)    /* Make sure it's all  */
      junk[j] = '\0';           /* zeroes...           */

   for (j = 0; j < 5; j++)
      {
      if (protos[j].first_char == prot)
         break;
      }
   j = protos[j].entry;
   c = m = ctl.protocols[j];
   p = NULL;
   while (*m)                   /* Until end of string */
      {
      if ((*m == '\\') || (*m == ':'))  /* Look for last path  */
         p = m;                 /* Delimiter           */
      m++;
      }
   m = &junk[0];
   /* It doesn't pay to be too smart here. Dots can appear in dir names   */
   while (c != p)               /* Copy to last '\'    */
      *m++ = *c++;
   while (*c != '.')            /* Then to the dot     */
      *m++ = *c++;
   strcat (&junk[0], ".ctl");   /* Then add extension  */

   /*
    * At this point we have the Control File name in (junk), Now let's open
    * the file and put our good stuff in there. 
    */

   unlink (junk);               /* Delete old copies   */
   if ((ctlfile = fopen (junk, "a")) == NULL)   /* Try to open it      */
      {
      status_line ("!Couldn't open CTL file: %s", junk);
      return;
      }

   errno = 0;
   fprintf (ctlfile, "Port %d\n", (port_ptr + 1));      /* Port n              */
   if (errno)
      goto err;
   if (lock_baud)
      i = ctl.max_baud;
   else
      i = cur_baud;

   fprintf (ctlfile, "Modem %x %x %x %x %x\n",  /* All modem params    */
         (port_ptr + 1), i, ctl.handshake_mask, ctl.carrier_mask, cur_baud);
   if (errno)
      goto err;
   fprintf (ctlfile, "Baud %d\n", cur_baud);    /* Baud Rate           */
   if (errno)
      goto err;
   fprintf (ctlfile, "%s %s\n", cmd, name);     /* Actual command      */
   if (errno)
      {
err:
      status_line ("!Error writing line to CTL file");
      fclose (ctlfile);
      errno = 0;
      return;
      }
   fclose (ctlfile);
   if (errno)
      {
      status_line ("!Error closing CTL file: %s", junk);
      errno = 0;
      return;
      }
   /* The file is now written. Turn off everything. */

   if (!share)
      MDM_DISABLE ();           /* Turn off FOSSIL     */

   if (status_log != NULL)
      fclose (status_log);      /* Close status log    */

   /* We're all set. Build the command and execute it. */

   c = ctl.protocols[j];
   sprintf (e_input, "%s %s -p%d -b%d %s", c, c, (port_ptr + 1), cur_baud, junk);
   system (e_input);            /* Execute command     */

   /* Back from external protocol. Turn it all back on. */

   if (Cominit (port_ptr) != 0x1954)    /* FOSSIL back on      */
      {
      cprintf ("\r\nDarn!  The FOSSIL seems to have gone away!  Exiting\r\n");
      exit (1);
      }

   if (status_log != NULL)      /* Reopen status log   */
      {
      if ((status_log = fopen (ctl.log_name, "aa")) == NULL)
         {
         cprintf ("\r\nCannot re-open logfile\r\n");
         }
      }

   MDM_ENABLE (btypes[baud].rate);      /* Reset baud rate     */
   XON_ENABLE ();               /* and reenable XON/OF */
}
